"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
var Context = /** @class */ (function () {
    /**This constructor will recieve singed messages for any transactions
     * and return the address which the message came from to be used as
     * context variable in other scripts.
     */
    function Context(ethereumAccountId) {
        this.ethereumAccountId = ethereumAccountId;
    }
    Context.prototype.getEtheriumAccountId = function () {
        return this.ethereumAccountId;
    };
    Context.signAccountId = function (accountId) {
        console.log("Signing accountId " + accountId);
        var token = jsonwebtoken_1.default.sign({ authorization: accountId }, Context.PRIVATE_KEY, {
            audience: 'HealthAnalyticsEngine',
            issuer: 'SmartContractBackend'
        });
        console.log("Signed token: " + token);
        return token;
    };
    Context.verifyToken = function (token) {
        try {
            var decodedToken = jsonwebtoken_1.default.verify(token, Context.PRIVATE_KEY, {
                audience: 'HealthAnalyticsEngine',
                issuer: 'SmartContractBackend'
            });
            return decodedToken.authorization;
        }
        catch (err) {
            console.error(err);
            return undefined;
        }
    };
    Context.PRIVATE_KEY = "DON'T STORE YOUR PRIVATE KEY LIKE THIS PLEASE, IM JUST FUDGING";
    return Context;
}());
exports.Context = Context;
//# sourceMappingURL=context.js.map