"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var cheerio_1 = __importDefault(require("cheerio"));
var memory_cache_1 = __importDefault(require("memory-cache"));
var CrawlerService = /** @class */ (function () {
    function CrawlerService() {
        this.BASE_GOOGLE_LINK = 'https://www.google.com/search?q=';
    }
    CrawlerService.prototype.searchForWebLinks = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var cacheResult, queryString, body, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cacheResult = memory_cache_1.default.get(query);
                        if (cacheResult != null) {
                            return [2 /*return*/, memory_cache_1.default.get(query)];
                        }
                        queryString = "How to " + query.trend + " " + query.unit + " healthy";
                        return [4 /*yield*/, this.retrieveWebPages(queryString)];
                    case 1:
                        body = _a.sent();
                        if (!body) {
                            console.error('Unable to retrieve search body');
                            return [2 /*return*/, null];
                        }
                        return [4 /*yield*/, this.scrapeTitleAndLinks(body)];
                    case 2:
                        result = _a.sent();
                        if (result.length > 0) {
                            memory_cache_1.default.put(query, result, 600000); //10 minutes
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    CrawlerService.prototype.retrieveWebPages = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var searchQuery, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (query == null) {
                            return [2 /*return*/, null];
                        }
                        searchQuery = encodeURI(this.BASE_GOOGLE_LINK + query);
                        return [4 /*yield*/, axios_1.default.get(searchQuery, {
                                headers: {
                                    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:70.0) Gecko/20100101 Firefox/70.0'
                                }
                            })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    CrawlerService.prototype.scrapeTitleAndLinks = function (body) {
        return __awaiter(this, void 0, void 0, function () {
            var data, $;
            return __generator(this, function (_a) {
                data = [];
                $ = cheerio_1.default.load(body);
                $('.S3Uucc').each(function (i, elem) {
                    var title = $(elem).text();
                    data.push({ title: title, link: '' });
                });
                $('.r').each(function (i, elem) {
                    var link = $(elem)
                        .find('a')
                        .attr('href');
                    if (link != undefined) {
                        data[i].link = link;
                    }
                });
                return [2 /*return*/, data.filter(function (page) { return page.link != ''; })];
            });
        });
    };
    return CrawlerService;
}());
exports.CrawlerService = CrawlerService;
//# sourceMappingURL=crawler-service.js.map