"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var web3_1 = __importDefault(require("web3"));
var dotenv_1 = __importDefault(require("dotenv"));
var Web3EthPersonal = require('web3-eth-personal');
var web3personal = new Web3EthPersonal(process.env.BLOCKCHAIN_URL);
dotenv_1.default.config();
var web3 = new web3_1.default(process.env.BLOCKCHAIN_URL);
function createNewAccount(privateKey) {
    return __awaiter(this, void 0, void 0, function () {
        var accounts, originalNumberOfAccounts, newAccountAddress, updatedAccounts, updatedNumberOfAccounts, val;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, web3personal.getAccounts()];
                case 1:
                    accounts = _a.sent();
                    if (!accounts) {
                        console.error('Could not retrieve accounts');
                        return [2 /*return*/, null];
                    }
                    originalNumberOfAccounts = accounts.length;
                    if (privateKey.substring(0, 2) !== '0x') {
                        privateKey = '0x' + privateKey;
                    }
                    return [4 /*yield*/, web3.eth
                            .personal.importRawKey(privateKey, 'password')];
                case 2:
                    newAccountAddress = _a.sent();
                    if (!newAccountAddress) {
                        console.error('Could not retrieve new account address');
                        return [2 /*return*/, null];
                    }
                    return [4 /*yield*/, web3personal.getAccounts()];
                case 3:
                    updatedAccounts = _a.sent();
                    updatedNumberOfAccounts = updatedAccounts.length;
                    /**checks to see if we have same number of accounts before and after import
                     * and returns null if yes, meaning no new account was added; if same account
                     * tries to register twice
                     */
                    if (updatedNumberOfAccounts == originalNumberOfAccounts) {
                        console.error('Previous number of accounts === current accounts');
                        return [2 /*return*/, null];
                    }
                    val = web3.utils.toWei('10');
                    web3.eth.sendTransaction({
                        from: updatedAccounts[0],
                        to: newAccountAddress,
                        value: val
                    });
                    return [2 /*return*/, newAccountAddress];
            }
        });
    });
}
exports.createNewAccount = createNewAccount;
/** The above accounts are created as locked account. This means whenever want to deploy a contract
  * with them we need to unlock them. To unlock use the snippet of code below:
        let acc_unlock = address of the account that needs to be unlocked;
        web3.eth.personal.unlockAccount(acc_unlock, 'password', 1000);
    */
//# sourceMappingURL=create-account-service.js.map