"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
/**
 * Loads contract address that was migrated by truffle
 * @param contractName Base name of contract (UserDescriptors instead of UserDescripts.sol)
 */
function loadContractAddress(contractName) {
    var rawJson = fs_1.default.readFileSync("./build/contracts/" + contractName + ".json");
    var contractAddresses = JSON.parse(rawJson.toString());
    if (contractAddresses.contractName !== contractName) {
        console.error('Could not find Truffle ABI of ' + contractName);
        return '';
    }
    if (contractAddresses.networks == undefined) {
        console.error('Could not find networks in Truffle ABI of ' + contractName);
        return '';
    }
    for (var _i = 0, _a = Object.keys(contractAddresses.networks); _i < _a.length; _i++) {
        var key = _a[_i];
        return contractAddresses.networks[key].address;
    }
    console.error('Could not find address');
    return '';
}
exports.default = loadContractAddress;
//# sourceMappingURL=contract-address-loader.js.map