"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeDefs = "\ntype Verify {\n\taddress: String!\n}\n\ntype Create {\n\tnewKey: String!\n}\n\nextend type Mutation {\n\tverify(signedMessage: String!): Verify!\n\tcreateNewAccount(privateKey: String!): Create!\n}\n\nextend type Query {\n\tgetBalance: Float!\n}\n\nschema {\n\tquery: Query\n\tmutation: Mutation\n\tsubscription: Subscription\n}\n\ntype Query {\n\t_: Boolean\n}\n\ntype Mutation {\n\t_: Boolean\n}\n\ntype Subscription {\n\t_: Boolean\n}\n\nenum QueryTrend {\n\tgain\n\tlose\n\tmaintain\n}\n\ntype WebPage {\n\ttitle: String!\n\tlink: String!\n}\n\nextend type Query {\n\tgetWebsiteSuggestions(unitName: String!, trend: QueryTrend!, amount: Int): [WebPage!]!\n}\n\nenum Trend {\n\tUP\n\tSAME\n\tDOWN\n}\n\ntype DailyTrend {\n\tunit: String!\n\tvalue: Float!\n\ttrend: Trend\n}\n\nextend type Query {\n\tgetDailyWeight: DailyTrend\n\tgetDailyBMI: DailyTrend\n}\n\nextend type Query {\n\tgetValuesForUnitGlobal(unit: String!): [Descriptor!]!\n\tgetAllAvailableUnitsGlobal: [String!]!\n\tgetLatestUnitValueGlobal(unit: String!): Float!\n\tgetPaginatedDescriptorsGlobal(\n\t\tunit: String!\n\t\tstart: Int!\n\t\tcount: Int!\n\t): [Descriptor!]!\n\tgetAverageForUnit(unit: String!, count: Int): Float!\n}\n\nextend type Mutation {\n\tinsertValueGlobal(\n\t\tunit: String!\n\t\tvalue: Float!\n\t\tlongitude: Float\n\t\tlatitude: Float\n\t): String!\n}\n\ntype LocalizedHelloWorld {\n\tjava: String!\n\tpython: String!\n\tcpp: String!\n\tjavascript: String!\n}\n\ntype HelloWorldEvent {\n\tmsg: String!\n}\n\nextend type Query {\n\tlocalizedHelloWorld: LocalizedHelloWorld!\n}\n\nextend type Subscription {\n\thelloWorldSubscription: HelloWorldEvent!\n}\ntype Descriptor {\n\tunit: String!\n\tvalue: Float!\n\tlongitude: Float!\n\tlatitude: Float!\n\tunixTimestamp: Float!\n}\n\nextend type Query {\n\tgetValuesForUnit(unit: String!): [Descriptor!]!\n\tgetAllAvailableUnits: [String!]!\n\tgetLatestUnitValue(unit: String!): Float!\n\tgetLengthOfDescriptor(unit: String!): Int!\n\tgetPaginatedDescriptors(\n\t\tunit: String!\n\t\tstart: Int!\n\t\tcount: Int!\n\t): [Descriptor!]!\n}\n\nextend type Mutation {\n\tinsertValue(\n\t\tunit: String!\n\t\tvalue: Float!\n\t\tlongitude: Float\n\t\tlatitude: Float\n\t): String!\n}\n\nenum TransactionResponse {\n\tTRANSACTION_HASH\n\tCONFIRMATION\n\tRECIEPT\n\tERROR\n}\n\ntype InsertValueResponse {\n\ttransactionHash: String!\n\tresponseType: TransactionResponse!\n\tmessage: String!\n}\n\nextend type Subscription {\n\tinsertValueSubscription: InsertValueResponse!\n}\n\n";
//# sourceMappingURL=index.js.map